  'MLX90614 IR camera support
  
  'where to find
  const SA=&hB4/2     'I2C 7 bit slave address is &h5A
  
  'I2C bus open at 100kHz (max for MLX90614)
  setpin gp0,gp1,I2C
  I2C open 100,100
  
  wh=rgb(white)
  gr=rgb(green)
  cy=rgb(cyan)
  
  'user interface
  cls
  text 0,0,"Logging tool for MLX90614 sensor",,,,gr
  text 0,24,"Tambient          Tsensor",,,,wh
  text 0,60,"Type any key to start logging",,,,wh
  do
    text 0,36,str$(gettemp(0),4,2)+"          "+str$(gettemp(1),4,2),,,,cy
    pause 650
  loop while inkey$=""
  
  'define log file
  text 0,84,"Type LOG file name (no suffix), then <enter> "
  input a$
  text 0,96,"Storing data in A:/"+a$+".csv"
  
  'open log file and print header
  open "a:/"+a$+".csv" for output as #1
  print #1,"log data from MLX90614-DCI sensor"
  print #1,date$;",";time$
  
  'define log time
  Tick=1000 'ms
  Trun=60000 'ms
  
  'write the data to the file
  Tnew=timer+Tick
  Tend=Timer+Trun
  dim dat(int(Trun/Tick))   'array for temp storage
  
  i=0
  do
    dat(i)=gettemp(1)
    print #1,str$(dat(i),4,2)
    
    text 0,120,"Actual Value = "+str$(dat(i),4,2)+" C",,,,cy
    inc i
    
    do : loop while timer<Tnew     'wait for time to pass
    Tnew=timer+Tick
    
  loop while Timer<Tend            'until end of run
  
  close #1
  text 0,120,"Done                          ",,,,gr
end

  
  'main loop
  do
    print
    print "Tambient = ";gettemp(0)
    print "Tsensor0 = ";gettemp(1)
    'print "Tsensor1 = ";gettemp(2)
    pause 650     'conversion time MLX90614-DCI
  loop
  
  'read MLX90614 registers 6 or 7 (or 8) containing Tamb, T0 (,T1)
function gettemp(chan) as float
  
  local da%(2)
  I2C write SA,1,1,chan+6
  I2C read SA,0,3,da%()
  gettemp=(da%(0)+256*da%(1))/50 - 273.15 '0.02 degrees C resolution
  
  'compensation for whatever reason, just noticed difference of 0.3 degree
  if chan=1 then inc gettemp,-0.3
  
  
end function
